// Craig S. Kaplan
//
// A simple demonstration of drawing a 3D grid of spheres
// tumbling around.  Note the triply-nested loop.  That's
// pretty crazy.  I wouldn't ask you to work with triple
// loops in class, but I don't mind demonstrating them.
// It's a pretty natural consequence of working in 3D.

void setup()
{
  size( 500, 500, P3D );
  // Tell processing that we'll be happy with fairly coarse
  // spheres (not that many triangles used to draw a sphere).
  sphereDetail( 10 );
}

void draw()
{
  background( 50 );
  lights();
  fill( 255, 0, 0 );
  noStroke();

  pushMatrix();
  translate( width/2, height/2, 0 );
  rotateX( frameCount / 77.0 );
  rotateY( frameCount / 100.0 );
  scale( 50 );

  for ( int x = 0; x < 5; ++x ) {
    for ( int y = 0; y < 5; ++y ) {
      for ( int z = 0; z < 5; ++z ) {
        pushMatrix();
        translate( -2 + x, -2 + y, -2 + z );
        sphere( 0.25 );
        popMatrix();
      }
    }
  }
  
  popMatrix();
}