// Craig S. Kaplan
//
// A slightly more advanced demonstration of a 3D box.
// Rotate the box and turn on some more realistic lights.

void setup()
{
  // Note the use of "P3D" in size().  That tells
  // Processing to use 3D graphics for this sketch.
  size( 500, 500, P3D );
}

void draw()
{
  background( 50 );
  fill( 255 );
  noStroke();

  // Tell Processing to use more realistic
  // shading on 3D objects.
  lights();

  pushMatrix();
  translate( width/2, height/2, 0 );
  // Rotate the box by an amount determined by the
  // current frame count, so that it'll just rotate
  // by itself forever.
  rotateY( frameCount / 100.0 );
  scale( 250 );
  box( 1, 1, 1 );
  popMatrix();
}